
package net.brutex.xservices.types.alfevent;

import java.util.HashMap;
import java.util.Map;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlAnyAttribute;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;


/**
 * 
 *                 EventControlType is a container for that portion of an
 *                 ALF Event that is generally set by the ALF EventManager.
 *                 In some cases, ALF compliant tools may set some fields,
 *                 in particular when the event is a result of an ALF
 *                 service call to that tool from a ServiceFlow.
 *             
 * 
 * <p>Java-Klasse für EmBaseType complex type.
 * 
 * <p>Das folgende Schemafragment gibt den erwarteten Content an, der in dieser Klasse enthalten ist.
 * 
 * <pre>
 * &lt;complexType name="EmBaseType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="EmEventId" type="{http://www.eclipse.org/alf/schema/EventBase/1}EventIdType"/>
 *         &lt;element name="EmTimestamp" type="{http://www.eclipse.org/alf/schema/EventBase/1}TimestampType"/>
 *         &lt;element name="PrecedingEmEventId" type="{http://www.eclipse.org/alf/schema/EventBase/1}EventIdType"/>
 *         &lt;element name="ApplicationName" type="{http://www.eclipse.org/alf/schema/EventBase/1}ApplicationNameType"/>
 *         &lt;element name="EventMatchName" type="{http://www.eclipse.org/alf/schema/EventBase/1}EventMatchNameType"/>
 *         &lt;element name="ServiceFlowName" type="{http://www.eclipse.org/alf/schema/EventBase/1}ServiceFlowNameType"/>
 *         &lt;element name="ServiceFlowId" type="{http://www.eclipse.org/alf/schema/EventBase/1}ServiceFlowIdType"/>
 *         &lt;element name="Callback" type="{http://www.w3.org/2001/XMLSchema}boolean"/>
 *         &lt;element name="Environment" type="{http://www.eclipse.org/alf/schema/EventBase/1}EnvironmentType"/>
 *         &lt;element name="EmUser" type="{http://www.eclipse.org/alf/schema/EventBase/1}CredentialsType"/>
 *         &lt;element name="AttemptCount" type="{http://www.w3.org/2001/XMLSchema}int" minOccurs="0"/>
 *         &lt;element name="EmExtension" type="{http://www.eclipse.org/alf/schema/EventBase/1}EmExtensionType" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;anyAttribute/>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EmBaseType", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", propOrder = {
    "emEventId",
    "emTimestamp",
    "precedingEmEventId",
    "applicationName",
    "eventMatchName",
    "serviceFlowName",
    "serviceFlowId",
    "callback",
    "environment",
    "emUser",
    "attemptCount",
    "emExtension"
})
public class EmBaseType {

    @XmlElement(name = "EmEventId", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String emEventId;
    @XmlElement(name = "EmTimestamp", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar emTimestamp;
    @XmlElement(name = "PrecedingEmEventId", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String precedingEmEventId;
    @XmlElement(name = "ApplicationName", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String applicationName;
    @XmlElement(name = "EventMatchName", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String eventMatchName;
    @XmlElement(name = "ServiceFlowName", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String serviceFlowName;
    @XmlElement(name = "ServiceFlowId", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String serviceFlowId;
    @XmlElement(name = "Callback", namespace = "http://www.eclipse.org/alf/schema/EventBase/1")
    protected boolean callback;
    @XmlElement(name = "Environment", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected String environment;
    @XmlElement(name = "EmUser", namespace = "http://www.eclipse.org/alf/schema/EventBase/1", required = true)
    protected CredentialsType emUser;
    @XmlElement(name = "AttemptCount", namespace = "http://www.eclipse.org/alf/schema/EventBase/1")
    protected Integer attemptCount;
    @XmlElement(name = "EmExtension", namespace = "http://www.eclipse.org/alf/schema/EventBase/1")
    protected EmExtensionType emExtension;
    @XmlAnyAttribute
    private Map<QName, String> otherAttributes = new HashMap<QName, String>();

    /**
     * Ruft den Wert der emEventId-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEmEventId() {
        return emEventId;
    }

    /**
     * Legt den Wert der emEventId-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEmEventId(String value) {
        this.emEventId = value;
    }

    /**
     * Ruft den Wert der emTimestamp-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getEmTimestamp() {
        return emTimestamp;
    }

    /**
     * Legt den Wert der emTimestamp-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setEmTimestamp(XMLGregorianCalendar value) {
        this.emTimestamp = value;
    }

    /**
     * Ruft den Wert der precedingEmEventId-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPrecedingEmEventId() {
        return precedingEmEventId;
    }

    /**
     * Legt den Wert der precedingEmEventId-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPrecedingEmEventId(String value) {
        this.precedingEmEventId = value;
    }

    /**
     * Ruft den Wert der applicationName-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getApplicationName() {
        return applicationName;
    }

    /**
     * Legt den Wert der applicationName-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setApplicationName(String value) {
        this.applicationName = value;
    }

    /**
     * Ruft den Wert der eventMatchName-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEventMatchName() {
        return eventMatchName;
    }

    /**
     * Legt den Wert der eventMatchName-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEventMatchName(String value) {
        this.eventMatchName = value;
    }

    /**
     * Ruft den Wert der serviceFlowName-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getServiceFlowName() {
        return serviceFlowName;
    }

    /**
     * Legt den Wert der serviceFlowName-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setServiceFlowName(String value) {
        this.serviceFlowName = value;
    }

    /**
     * Ruft den Wert der serviceFlowId-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getServiceFlowId() {
        return serviceFlowId;
    }

    /**
     * Legt den Wert der serviceFlowId-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setServiceFlowId(String value) {
        this.serviceFlowId = value;
    }

    /**
     * Ruft den Wert der callback-Eigenschaft ab.
     * 
     */
    public boolean isCallback() {
        return callback;
    }

    /**
     * Legt den Wert der callback-Eigenschaft fest.
     * 
     */
    public void setCallback(boolean value) {
        this.callback = value;
    }

    /**
     * Ruft den Wert der environment-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEnvironment() {
        return environment;
    }

    /**
     * Legt den Wert der environment-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEnvironment(String value) {
        this.environment = value;
    }

    /**
     * Ruft den Wert der emUser-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link CredentialsType }
     *     
     */
    public CredentialsType getEmUser() {
        return emUser;
    }

    /**
     * Legt den Wert der emUser-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link CredentialsType }
     *     
     */
    public void setEmUser(CredentialsType value) {
        this.emUser = value;
    }

    /**
     * Ruft den Wert der attemptCount-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getAttemptCount() {
        return attemptCount;
    }

    /**
     * Legt den Wert der attemptCount-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setAttemptCount(Integer value) {
        this.attemptCount = value;
    }

    /**
     * Ruft den Wert der emExtension-Eigenschaft ab.
     * 
     * @return
     *     possible object is
     *     {@link EmExtensionType }
     *     
     */
    public EmExtensionType getEmExtension() {
        return emExtension;
    }

    /**
     * Legt den Wert der emExtension-Eigenschaft fest.
     * 
     * @param value
     *     allowed object is
     *     {@link EmExtensionType }
     *     
     */
    public void setEmExtension(EmExtensionType value) {
        this.emExtension = value;
    }

    /**
     * Gets a map that contains attributes that aren't bound to any typed property on this class.
     * 
     * <p>
     * the map is keyed by the name of the attribute and 
     * the value is the string value of the attribute.
     * 
     * the map returned by this method is live, and you can add new attribute
     * by updating the map directly. Because of this design, there's no setter.
     * 
     * 
     * @return
     *     always non-null
     */
    public Map<QName, String> getOtherAttributes() {
        return otherAttributes;
    }

}
